<template>
    <section>
        <div>
            <h2>Ride Search</h2>
        </div>
        <SearchBar v-bind:synapse="synapse"> </SearchBar> 
        <flash-message transitionIn="animated swing" class="myCustomClass"></flash-message>

        <div v-if="rides">
            <RidesCard v-bind:rides="rides" v-bind:currentUser="user"></RidesCard>
        </div>
        <div v-if="openRides">
            <OpenRideList v-bind:openRides="openRides" v-bind:currentUser="user"></OpenRideList>
        </div>
        <div v-if="noRides">
            <div class="row">
                <div class="col-md-12 text-center divider-blue" style="padding: 50px 15%;">

                    <h2>There are no rides for this trip yet.</h2>
                    <p>Please try a general location (a town or city instead of a full address) and/or check again in a few days! Want to be notifed if someone posts this ride?</p>

                    <form method="get" action="/ride_request/create">
                        <button class="btn btn-primary top-margin-15">Create Ride Alert</button>
                    </form>

                </div>

                <div class="col-md-12 text-center" style="padding: 50px 0px;">

                    <h3>We need more drivers for this route!</h3>
                    <p>Why don't you give it a try and create a ride?</p>
                    <img src="/images/car.png" class="img-responsible" width="75" />
                    <br/><br/>
                    <a href="/rides/rides/create" class="btn btn-info"> Create A Ride </a>

                </div>
            </div>
        </div>
    </section>
</template>

<script>
    import RidesCard from "./RidesCard";
    import SearchBar from "./SearchBar";
    import OpenRideList from "./OpenRideList";
    import axios from 'axios';

    export default {
        name: "Ridelist",

        components:{SearchBar, RidesCard, OpenRideList},
        props:['normalrides', 'open', 'states', 'event'],

        mounted(){


            if(this.open){
                this.openRides = JSON.parse(this.open);
            }

            var location = window.location.pathname;

            if(location == "/synapse"){
                this.getSignapse();
                this.synapse = true;
            }

            if(this.currentUser){
                this.user = JSON.parse(this.currentUser);
            }
            this.$root.$on('PopulateRides', (data) => {
                
                if(data.rides != null)
                    this.rides = data.rides;
                if(data.openRides != null)
                    this.openRides = data.openRides;
                this.noRides = false;
            });

            this.$root.$on('NoRides', () => {
                this.rides = null;
                this.noRides = true;
            })
        },
        data(){
            return{
                openRides:'',
                rides:'',
                noRides:false,
                user:'',
                synapse: false,
            }
        },
        methods:{
            PopulateRides(data){
                this.rides = data.rides;
                this.openRides = data.openRides;
            },
            NoRides(){
                this.noRides = true;
                this.rides = false;
                this.openRides = false;
                this.$root.$emit('cleandata');
            },
            getSignapse(){
                axios.post('/synapse/getRides', {
                        body:{
                            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
                            'date':null,
                        }
                    }).then(response => {
                        this.isLoading = false;
                        if(response.data.action === 1) {
                            this.$root.$emit('PopulateRides', response.data);
                        }else{
                            this.$root.$emit('NoRides', 'No Rides');
                        }

                    }).catch(e => {
                        this.isLoading = false;
                        this.flash('Server 500 error please try again', 'error',{timeout: 4500});
                        console.log(e);
                    })
            }
        }
    }
</script>

<style scoped>

</style>